clear all
num_of_layers=3;
gpuDevice(1)

load result_MatDBN_Topics0_101iid_CrossValidation_HiddenDeep9100_4levels_13.mat

tmp=load('apascal_train_data.mat');
attributes=tmp.attributes;

img_classes=tmp.img_classes;
num_of_classes=length(unique(img_classes));
tmp=load('feat_apascal_train_words.mat');
feat0=tmp.feat;


% tmp=load('result_MatDBN_Topics0_101iid_CrossValidation_HiddenDeep9100.mat');
% W{2}=tmp.W{end};
% b{2}=tmp.b{end};
% Beta{2}=tmp.Beta{end};

num=1000+128+256;
factor=200;
feat=cell(7,3);
for i=1:7
    feat{i,1}=(round(feat0(1+(i-1)*num:(i-1)*num+1000,:)...
        ./repmat(eps+sum(feat0(1+(i-1)*num:(i-1)*num+1000,:)),[1000,1])*factor)).';
    feat{i,2}=(round(feat0(1001+(i-1)*num:(i-1)*num+1128,:)...
        ./repmat(eps+sum(feat0(1001+(i-1)*num:(i-1)*num+1128,:)),[128,1])*factor)).';
    feat{i,3}=(round(feat0(1129+(i-1)*num:(i-1)*num+num,:)...
        ./repmat(eps+sum(feat0(1129+(i-1)*num:(i-1)*num+num,:)),[256,1])*factor)).';
end

un=unique(img_classes);
VIndices=zeros(1,length(img_classes));
class_props=zeros(length(un),1);
for i=1:length(un)
    VIndices(strcmp(un(i),img_classes))=i;
end
k=1;
tmp=[];
tmp2=[];
BetaMat=[];
BetaMat2=[];

for i=1:7
    for j=1:3
        num_words_hist=sum(feat{i,j},2);
        tmp=[tmp ; double(gather((gpuArray(single(W{1}{k,i,j})).'*gpuArray(single(feat{i,j})).'+b{1}{k,i,j}*num_words_hist.')))];
        tmp2=[tmp2 ; double(gather((gpuArray(single(W{2}{k,i,j})).'*gpuArray(single(feat{i,j})).'+b{2}{k,i,j}*num_words_hist.')))];
        
        BetaMat=[BetaMat; Beta{1}{k,i,j}];
        BetaMat2=[BetaMat2; Beta{2}{k,i,j}];
    end
end

VWpb0_train=tmp(:,group_indices_train+1);
VWpb0_test=tmp(:,group_indices_test+1);
VWpb=tmp2;


tmp=load('apascal_test_data.mat');
img_classes=tmp.img_classes;
un=unique(img_classes);
VIndices_test=zeros(1,length(img_classes));
for i=1:length(un)
    VIndices_test(strcmp(un(i),img_classes))=i;
end

tmp=load('feat_apascal_test_words.mat');
num_of_hist_boxes=7;
feat0=tmp.feat;
num=1000+128+256;
factor=200;
feat=cell(7,3);
for i=1:7
    feat{i,1}=(round(feat0(1+(i-1)*num:(i-1)*num+1000,:)...
        ./repmat(eps+sum(feat0(1+(i-1)*num:(i-1)*num+1000,:)),[1000,1])*factor)).';
    feat{i,2}=(round(feat0(1001+(i-1)*num:(i-1)*num+1128,:)...
        ./repmat(eps+sum(feat0(1001+(i-1)*num:(i-1)*num+1128,:)),[128,1])*factor)).';
    feat{i,3}=(round(feat0(1129+(i-1)*num:(i-1)*num+num,:)...
        ./repmat(eps+sum(feat0(1129+(i-1)*num:(i-1)*num+num,:)),[256,1])*factor)).';
end
tmp=[];
for i=1:7
    for j=1:3
        num_words_hist=sum(feat{i,j},2);
        tmp=[tmp ;double(gather((gpuArray(single(W{2}{k,i,j})).'*gpuArray(single(feat{i,j})).'+b{2}{k,i,j}*num_words_hist.')))];
    end
end
VWpb_test=tmp;


sgmVWpb0_train=(1)./(exp(-VWpb0_train.')+1);
sgmVWpb0_test=(1)./(exp(-VWpb0_test.')+1);

sgmVWpb=(1)./(exp(-VWpb.')+1);
sgmVWpb_test=(1)./(exp(-VWpb_test.')+1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% second layer

VWpb02_train=double(gather((gpuArray(single(W{1}{2,1,1})).'*[gpuArray(single(sgmVWpb0_train)).';ones(1,size(sgmVWpb0_train,1))]+b{1}{2,1,1}*ones(1,size(sgmVWpb0_train,1)))));
VWpb02_test=double(gather((gpuArray(single(W{1}{2,1,1})).'*[gpuArray(single(sgmVWpb0_test)).';ones(1,size(sgmVWpb0_test,1))]+b{1}{2,1,1}*ones(1,size(sgmVWpb0_test,1)))));
VWpb2=double(gather((gpuArray(single(W{2}{2,1,1})).'*[gpuArray(single(sgmVWpb)).';ones(1,size(sgmVWpb,1))]+b{2}{2,1,1}*ones(1,size(sgmVWpb,1)))));
VWpb_test2=double(gather((gpuArray(single(W{2}{2,1,1})).'*[gpuArray(single(sgmVWpb_test)).';ones(1,size(sgmVWpb_test,1))]+b{2}{2,1,1}*ones(1,size(sgmVWpb_test,1)))));

ind02=find(sum(Beta{1}{2,1,1},2)>0.001);
ind2=find(sum(Beta{2}{2,1,1},2)>0.001);
%%%%%%%%%
sgmVWpb02_train=(1)./(exp(-VWpb02_train.')+1);
sgmVWpb02_test=(1)./(exp(-VWpb02_test.')+1);
sgmVWpb2=(1)./(exp(-VWpb2.')+1);
sgmVWpb_test2=(1)./(exp(-VWpb_test2.')+1);
%%%%%%%%%
VWpb03_train=double(gather((gpuArray(single(W{1}{3,1,1})).'*[gpuArray(single(sgmVWpb02_train)).';ones(1,size(sgmVWpb02_train,1))]+b{1}{3,1,1}*ones(1,size(sgmVWpb02_train,1)))));
VWpb03_test=double(gather((gpuArray(single(W{1}{3,1,1})).'*[gpuArray(single(sgmVWpb02_test)).';ones(1,size(sgmVWpb02_test,1))]+b{1}{3,1,1}*ones(1,size(sgmVWpb02_test,1)))));

VWpb3=double(gather((gpuArray(single(W{2}{3,1,1})).'*[gpuArray(single(sgmVWpb2)).';ones(1,size(sgmVWpb2,1))]+b{2}{3,1,1}*ones(1,size(sgmVWpb2,1)))));
VWpb_test3=double(gather((gpuArray(single(W{2}{3,1,1})).'*[gpuArray(single(sgmVWpb_test2)).';ones(1,size(sgmVWpb_test2,1))]+b{2}{3,1,1}*ones(1,size(sgmVWpb_test2,1)))));

sgmVWpb03_train=(1)./(exp(-VWpb03_train.')+1);
sgmVWpb03_test=(1)./(exp(-VWpb03_test.')+1);

sgmVWpb3=(1)./(exp(-VWpb3.')+1);
sgmVWpb_test3=(1)./(exp(-VWpb_test3.')+1);

ind03=find(sum(Beta{1}{3,1,1},2)>0.001);
ind3=find(sum(Beta{2}{3,1,1},2)>0.001);
%%%%%%%%
%VWpb04_train=double(gather((gpuArray(single(W{1}{4,1,1})).'*[gpuArray(single(sgmVWpb03_train)).';ones(1,size(sgmVWpb03_train,1))]+b{1}{4,1,1}*ones(1,size(sgmVWpb03_train,1)))));
%VWpb04_test=double(gather((gpuArray(single(W{1}{4,1,1})).'*[gpuArray(single(sgmVWpb03_test)).';ones(1,size(sgmVWpb03_test,1))]+b{1}{4,1,1}*ones(1,size(sgmVWpb03_test,1)))));

%VWpb4=double(gather((gpuArray(single(W{2}{4,1,1})).'*[gpuArray(single(sgmVWpb3)).';ones(1,size(sgmVWpb3,1))]+b{2}{4,1,1}*ones(1,size(sgmVWpb3,1)))));
%VWpb_test4=double(gather((gpuArray(single(W{2}{4,1,1})).'*[gpuArray(single(sgmVWpb_test3)).';ones(1,size(sgmVWpb_test3,1))]+b{2}{4,1,1}*ones(1,size(sgmVWpb_test3,1)))));

%sgmVWpb04_train=(1)./(exp(-VWpb04_train.')+1);
%sgmVWpb04_test=(1)./(exp(-VWpb04_test.')+1);

%sgmVWpb4=(1)./(exp(-VWpb4.')+1);
%sgmVWpb_test4=(1)./(exp(-VWpb_test4.')+1);

%ind04=find(sum(Beta{1}{4,1,1},2)>0.01);
%ind4=find(sum(Beta{2}{4,1,1},2)>0.01);
%%%%%%%%
ind0=find(sum(BetaMat,2)>0.001);
ind=find(sum(BetaMat2,2)>0.001);

%%%%%%%%%%%%%%%
ind0=ind;
ind02=ind2;
ind03=ind3;
%ind04=ind4;
%%%%%%%%%%%%%
if num_of_layers==1
    features0_train=sgmVWpb0_train(:,ind0);
    features0_test=sgmVWpb0_test(:,ind0);
    features_train=sgmVWpb(:,ind);
    features_test=sgmVWpb_test(:,ind);
elseif num_of_layers==2
    features0_train=[sgmVWpb0_train(:,ind0) sgmVWpb02_train(:,ind02)];
    features0_test=[sgmVWpb0_test(:,ind0) sgmVWpb02_test(:,ind02)];

    features_train=[sgmVWpb(:,ind) sgmVWpb2(:,ind2)];
    features_test=[sgmVWpb_test(:,ind) sgmVWpb_test2(:,ind2)];
elseif num_of_layers==3
    features0_train=[sgmVWpb0_train(:,ind0) sgmVWpb02_train(:,ind02) sgmVWpb03_train(:,ind03)];
    features0_test=[sgmVWpb0_test(:,ind0) sgmVWpb02_test(:,ind02) sgmVWpb03_test(:,ind03)];% 

    features_train=[sgmVWpb(:,ind) sgmVWpb2(:,ind2) sgmVWpb3(:,ind3)];
    features_test=[sgmVWpb_test(:,ind) sgmVWpb_test2(:,ind2) sgmVWpb_test3(:,ind3)];
elseif num_of_layers==4
    features0_train=[sgmVWpb0_train(:,ind0) sgmVWpb02_train(:,ind02) sgmVWpb03_train(:,ind03) sgmVWpb04_train(:,ind04)];
    features0_test=[sgmVWpb0_test(:,ind0) sgmVWpb02_test(:,ind02) sgmVWpb03_test(:,ind03) sgmVWpb04_test(:,ind04)];

    features_train=[sgmVWpb(:,ind) sgmVWpb2(:,ind2) sgmVWpb3(:,ind3) sgmVWpb4(:,ind4)];
    features_test=[sgmVWpb_test(:,ind) sgmVWpb_test2(:,ind2) sgmVWpb_test3(:,ind3) sgmVWpb_test4(:,ind4)];
end
%%%%%%%%%%%%%
VIndices0_train=VIndices(group_indices_train+1);
VIndices0_test=VIndices(group_indices_test+1);
        
%%%%%%%%%%%%%%%%%%%%%
num_of_hidden_variables=ones(3,7,3);%2000;%200;%20;
for i=1:7
    num_of_hidden_variables(1,i,1)=800;
    num_of_hidden_variables(1,i,2)=200;
    num_of_hidden_variables(1,i,3)=300;
end
num_of_hidden_variables(2,1,1)=4000;
num_of_hidden_variables(3,1,1)=2000;
vct_level=[];
vct_cell=[];
vct_feature=[];
for i=1:7
    for j=1:3
        vct_level=[vct_level ones(1,k+num_of_hidden_variables(1,i,j))];
        vct_cell=[vct_cell ones(1,k+num_of_hidden_variables(1,i,j))*i];
        vct_feature=[vct_feature ones(1,k+num_of_hidden_variables(1,i,j))*j];
    end
end
vct_level=vct_level(ind);
vct_cell=vct_cell(ind);
vct_feature=vct_feature(ind);

if num_of_layers>1
    vct_level=[vct_level 2*ones(1,length(ind2))];
    vct_cell=[vct_cell 1*ones(1,length(ind2))];
    vct_feature=[vct_feature 1*ones(1,length(ind2))];
end
if num_of_layers>2
    vct_level=[vct_level 3*ones(1,length(ind3))];
    vct_cell=[vct_cell 1*ones(1,length(ind3))];
    vct_feature=[vct_feature 1*ones(1,length(ind3))];
end
%%%%%%%%%%%%%%%%%%%%%

save PASCAL_datasets_TopicsYHDeep13.mat VIndices VIndices_test features_train features_test VIndices0_train VIndices0_test features0_train features0_test vct_level vct_cell vct_feature
